/// common Edynn items, textures, etc.

#ifdef (port_colour)
//ports
#declare port_in=blob{
 threshold .5
 sphere {<0,0,0>,.5,1 scale z*.5}
 sphere {<0,0,-.2>,.25,-2
 	scale z*4
 	pigment {color port_colour}
 }
 cylinder{<0,0,-.1>,<0,0,.1>,.1,-1
 	pigment {color port_colour}
 }
}

#declare port_out=blob{
 threshold .5
 sphere {<0,0,0>,.5,1 scale z*.5}
 sphere {<0,0,-.2>,.25,-2
 	scale z*4
 	pigment {color port_colour}
 }
 /* sphere {<0,0,-.2>,.2,4
 scale z*4
 } */
 cylinder{<0,0,0>,<0,0,-.3>,.1,3}

}
#end

//lights
#declare Spot=light_source { <0, 0, 0>
	color Red
	spotlight
	radius 5
	falloff 250
	tightness 2
	area_light <-0.5, -1, -0.5>, <0.5, -1, 0.5>, 2, 2
	adaptive 1
	jitter
	looks_like {
	sphere{ <0,0,0>, 1
		texture {
		 pigment { color rgb <.99, .4, 0.1> }
		 finish {
		 	ambient .8
			diffuse .6
		 }
		}
		scale <1,.4,1>
	}
	}
	point_at <0, -2, 0>
}

#declare Light=union{
	object{Spot}
	torus{ 1,.1
		scale <1,3,1>
		translate y*.2
		pigment { color Gray }//rgb <.4, .4, .8> }
	}
}

//pipe texture
#declare bluePipes=
texture{
	pigment{color Blue}//rgb <.4, .4, .8>}
	finish{
		phong 1
		specular .5
		reflection .2
	}
}

/////////////////////////////////
//syla textures
//old one
#declare Syla=
texture{
 pigment {
 	wood color_map {// [0.1 color rgb <0.64, 0.36, 0.02>]
		[0.1 color rgb <0.64, 0.36, 0.02>]
		[0.8 color rgb <.91, .68, .07>]
		[0.7 color rgb <.62, .17, 0.1>]
	}
	turbulence 0.8
//      rotate x*90
//      scale<0.2,0.3,1>
 }
 normal{
 	gradient x
	normal_map{
		[0.3 bumps scale 2]
		[0.3 dents scale 3]
		[0.6 dents]
		[0.9 marble turbulence .5]
	}
	scale 2
 }
//} 
}
texture{ pigment{
//      marble
	agate
	color_map { [0.1 color rgbt <0.64, 0.36, 0.02, .5>]
		[0.8 color rgbt <.91, .68, .07, .5>]
		[0.7 color rgbt <.62, .17, 0, .5>]
	}
	turbulence 0.4
//      frequency 3
	lambda 1.5
	omega .8
	octaves 5
//      rotate x*90
	scale <8, 2, 1>
}}
////////////////////////
//more stripey texture
#declare Syla2=
texture{
 pigment {
 	wood color_map { [0.1 color rgb <0.64, 0.36, 0.02>]
		[0.8 color rgb <.91, .68, .07>]
		[0.7 color rgb <.62, .17, 0>]
	}
	turbulence 0.8
//      rotate x*90
//      scale<0.2,0.3,1>
 }
 normal{
 	gradient x
	normal_map{
		[0.3 bumps scale 2]
		[0.3 dents scale 3]
		[0.6 dents]
		[0.9 marble turbulence .5]
	}
	scale 2
 }
//} 
}
texture{ pigment{
//      marble
	agate
	color_map { [0.1 color rgbt <0.64, 0.36, 0.02, .5>]
		[0.8 color rgbt <.91, .68, .07, .5>]
		[0.7 color rgbt <.62, .17, 0, .5>]
	}
	turbulence 0.4
//      frequency 3
	lambda 1.5
	omega .8
	octaves 5
//      rotate x*90
	scale <8, 2, 1>
}}
texture{ pigment{
	gradient y
	scale 4
	turbulence .2
	color_map{
		[0.0 color rgbf <.91, .68, .17, .3>]
		[0.2 color rgbf <.81, .48, .27, .4>]
		[0.3 color rgbf <.81, .48, .27, .3>]
		[0.39 color rgbf<.92, .96, .90, .2>]
		[0.4 color rgbf <.81, .48, .27, .3>]
		[0.9 color rgbf <.91, .68, .17, .3>]
		[0.95 color rgbf<.91, .68, .17, .6>]
	}
}}
////////////////////////
//stripey texture without the white
#declare Syla3=
texture{
 pigment {
 	wood color_map { [0.1 color rgb <0.64, 0.36, 0.02>]
		[0.8 color rgb <.91, .68, .07>]
		[0.7 color rgb <.62, .17, 0>]
	}
	turbulence 0.8
//      rotate x*90
//      scale<0.2,0.3,1>
 }
 normal{
 	gradient x
	normal_map{
		[0.3 bumps scale 2]
		[0.3 dents scale 3]
		[0.6 dents]
		[0.9 marble turbulence .5]
	}
	scale 2
 }
//} 
}
texture{ pigment{
//      marble
	agate
	color_map { [0.1 color rgbt <0.64, 0.36, 0.02, .5>]
		[0.8 color rgbt <.91, .68, .07, .5>]
		[0.7 color rgbt <.62, .17, 0, .5>]
	}
	turbulence 0.4
//      frequency 3
	lambda 1.5
	omega .8
	octaves 5
//      rotate x*90
	scale <8, 2, 1>
}}
texture{ pigment{
	gradient y
	scale 4
	turbulence .2
	color_map{
		[0.0 color rgbf <.91, .68, .17, .3>]
		[0.2 color rgbf <.61, .28, .07, .4>]
		[0.3 color rgbf <.81, .38, .17, .3>]
		[0.39 color rgbf<.92, .48, .27, .2>]
		[0.4 color rgbf <.81, .38, .17, .3>]
		[0.9 color rgbf <.81, .58, .27, .3>]
		[0.95 color rgbf<.91, .68, .27, .6>]
	}
}}


//star background
#declare starfield=plane {z, -100
 rotate y*180
 texture {
 	pigment {
	 granite
	 color_map {
	  [ 0.000  0.275 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
	  [ 0.275  0.280 color rgb <.5,.5,.4> color rgb <.8,.8,.4> ]
	  [ 0.280  0.475 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
	  [ 0.475  0.480 color rgb <.4,.4,.5> color rgb <.4,.4,.8> ]
	  [ 0.480  0.685 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
	  [ 0.685  0.690 color rgb <.5,.4,.4> color rgb <.8,.4,.4> ]
	  [ 0.690  0.885 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
	  [ 0.885  0.890 color rgb <.5,.5,.5> color rgb < 1, 1, 1> ]
	  [ 0.890  1.000 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
	 }
	 turbulence 1
	 sine_wave
	 scale .5
	}
	finish { diffuse 0 ambient 1 }
 }
}


